Chapter 1 Introduction


Welcome to ComeBack!  ComeBack's powerful utilities will make you more
productive and provide you a more forgiving environment on the IBM PC.  You'll
be more productive by not having to continually re-enter your work.  Your PC
will be more forgiving of your mistakes.  With ComeBack you can easily recover
lost data in case of power failure, system errors, or your mistakes.  ComeBack
is easy to install and use.  Most of the time you won't even know that it is
there.

ComeBack provides the capability to recover files that were deleted, copied
over, or edited on your hard disk.  ComeBack consists of two programs:  a RAM
resident program or TSR, COMEBAKR, which keeps track of recoverable files and
ComeBack which is used to recover the lost files.  COMEBAKR is loaded once
when the system is powered up and uses less that 15 k of memory.  ComeBack is
used only when you want to recover a file.  ComeBack's features include:

100% recovery of up to the last 1000 deleted or overwritten files.
Flexible installation to match your particular needs
- Allows you to include or exclude up to 20 file extensions from recovery
- Allows you to limit the maximum number of recoverable files
- Allows you to limit the amount of disk space ComeBack uses.
Easily disabled to allow unprotected file activity
Can view the file being recovered
Easily removed from memory to make more RAM available
100% DOS, and Windows compatible

Chapter 2 Installation/Configuration


What does the Installation do?

ComeBack's installation performs 3 basic steps:

1.   Copies the ComeBack files you need from the distribution floppy into the
     hard disk directory of your choice.

2.   Sets up the configuration file to determine:
  a. The maximum number of recoverable files (default: 75)
  b. The files that will be excluded from or included in recovery (default:
     Include all files)
  c. The hard drives for which recovery is available (default: C:)
  d. The maximum amount of disk space ComeBack can use (default: 5 meg)
  e. The programs for which ComeBack is disabled (default:
     VIRUCIDE,SD,SPEEDBAK,MACE,COMPRESS)

3.   Optionally modifies your AUTOEXEC.BAT file to put ComeBack utilities in
     your path and to automatically start ComeBack when you re-boot.  Your
     original file will be renamed AUTOEXEC.WAS.

Things to Consider After you Install

There are six questions to be considered after you install ComeBack:

1.   How many recoverable "bak" files do you want ComeBack to keep?  A "bak"
     file is an earlier version of a file that you deleted or overwrote. 
     ComeBack maintains a list of these recoverable files (called the
     recovery list).  This decision should be based on the amount of
     available disk space you have on your hard disk(s) and the size of the
     files with which you work.  The installation program defaults to the
     maximum of 75 files.

2.   For which files do you want to provide recovery against inadvertent
     deletions or overwrites?  By default, ComeBack provides protection for
     all files on hard drives for which recovery is available.  To minimize
     the amount of disk space used, you may define a list of files which will
     be either excluded or included in ComeBack protection.  The list is
     specified using full DOS wild card conventions (* and ?).  For example,
     if you want to protect only your Lotus spreadsheets you would choose to
     include the following files:

      "*.WK?" 

     This would only protect files whose extensions begin with "WK".  If on
     the other hand you wanted to protect all files except your graph and
     print files and your two megabyte data base, you would choose to exclude
     the following list of files:

      "*.PIC,*.PRT,BIGDATA.DBF"

     Note: To exclude files with blank extensions, use two commas separated
     by a space.

3.   ComeBack will work on up to 10 drives and maintains a separate recovery
     list for each drive.  These can include networked drives (See notes on
     networking in Chapter 3)  as well as local drives.  By default, the
     installation provides protection only on the C drive.

4.   In addition, ComeBack will work on passive drives (like a floppy) by
     storing the deleted file in the first active drive (usually the C
     drive).  By default, the installation select no passive drives.

5.   ComeBack will also minimize the amount of disk space it uses is
     protecting your data.  It defaults to 5 megabytes.  If this is too high
     or too low, reconfigure ComeBack using CBCONFIG.

6.   For certain programs, ComeBack should be turned off.  Amoung others,
     these include Virus programs and disk defragmenters.  ComeBack defaults
     to exclude protection when the following programs are running:

     VIRUCIDE,SD,SPEEDBAK,MACE,COMPRESS

     If there are additional TSR virus programs or disk defragmenters for
     which you desire ComeBack to be automatically turned off, reconfigure
     ComeBack using CBCONFIG.

If you have no idea what any or all of this means, you do not need to do
anything. ComeBack's installation program will then choose acceptable
defaults.  If however, you desire to change any of these parameters, use the
CBCONFIG program to reconfigure ComeBack.

Once installed, it can be reconfigured to change ComeBack's list of protected
files. (See  "How to Reconfigure ComeBack).

How to Install ComeBack

The installation of ComeBack is quick and easy to perform.  To install
ComeBack, follow these simple steps:

1.   Insert the ComeBack disk into drive A (or B).
2.   Type A:INSTALL (or B:INSTALL), and press ENTER.
3.   To continue, follow the instructions on the screen.
4.   When the installation program is complete, open the door to drive A (or
     B), remove the disk and press CTRL+ALT+DEL to reboot the system.
5.   Verify that the utilities you chose, start up (look for the name,
     version and copyright notice).

NOTE: You must install ComeBack for it to work.  ComeBack will work with any
well behaved RAM resident program or TSR (like PC-Tools).  TSR's that have hot
keys should be installed in the AUTOEXEC.BAT after COMEBAKR.  This enables
ComeBack to catch any files deleted or modified by the TSR.

This is not done automatically during installation.

How to Reconfigure ComeBack

To reconfigure ComeBack after it is already installed, type:

[drive][path]CBCONFIG      followed by the {ENTER} key

and follow the instructions on the screen.  Note: The drive and the path (DOS
3.0 and greater) need not be specified if CBCONFIG is in your path.  This
applies to all such references throughout this manual.  If you allowed the
installation program to modify your AUTOEXEC.BAT file, you need not worry
about drive or path.


Chapter 3 Using ComeBack


How ComeBack is started

ComeBack consists of two programs: COMEBAKR (the RAM resident program) and
ComeBack (the recovery program).  COMEBAKR is required to be run before the
recovery can be performed.  Normally, COMEBAKR is started automatically when
you turn on your computer through the AUTOEXEC.BAT file.  If you did not
choose this during installation, at any time from the DOS prompt, it may be
placed in memory and started by specifying:

[drive][path]COMEBAKR     followed by the {ENTER}

Once started, COMEBAKR will always be there to protect your valuable data from
accidental deletions or overwriting.  See the notes at the end of chapter 3 on
using ComeBack for special switches that may be used in installing COMEBAKR.

How to Use ComeBack

When the infrequent but inevitable time comes when you need to recover a file
that you have accidentally overwritten or deleted, the ComeBack utility called
ComeBack may be used to completely recover your valuable data.  ComeBack may
be invoked from any directory (i.e. not necessarily from the directory where
you lost your file) with the following command at the DOS prompt:

[drive][path]COMEBACK [options] [drive][filename] and {ENTER}

The possible options are:

  /A - The list of recoverable files will be displayed in the order they
       were added to the ComeBack list.  The oldest addition to the list
       will be at the top of the list.
  /C - The files displayed will only be the recoverable files from the
       current directory.
  /H - Provides help in invoking ComeBack

The drive can be any drive specified at installation or during reconfiguration
for which ComeBack protection is provided.

The filename supports full DOS wild card naming conventions including "*" and
"?".  Specifying no drive and filename is the same as all files from the
default drive (*.*).

For example, if you wanted to recover a Lotus file but you could not remember
the name, (assuming ComeBack is in your path) you would type:

  COMEBACK *.WK?   followed by the {ENTER} key.

At this point, ComeBack provides a display containing:

1.   A sorted list of all the recoverable files that meet your file
     specification and the disk space they use
2.   Instructions on how to use ComeBack
3.   The possible path of the selected file
4.   The size and date of the current file that matches the selected file's
     path and name

This screen allows you to perform the following functions by pressing the
appropriate hot-key or by clicking your mouse on the appropriate button:

C -  compare the file in the cursor bar with another file. The default is the
     file with the same name. 
R -  recover the highlighted (selected) files or the file in the cursor bar. 
V -  view the file in the cursor bar, This works best with ASCII files.
S -  sort the file list by name, extension, date, oldest deleted or size.
U -  unselect all files highlighted in the file list
D -  delete files from FileBack's recovery list. Once these files are
     deleted, FileBack can not recover them.
X -  exit the program.
T -  changes the file on the cursor bar from selected to unselected and vice
     versa. 

Note: ComeBack may provide more than one path for the selected file.

You can at this point use hot keys or your mouse to:

1. Select a file (or files) for recovery, deletion, or comparison
2. Recover the selected file to anywhere
3. Delete the selected file from the recovery list
4. Compare the selected file to any file
5. Get Context sensitive Help

The right mouse button and escape key take you back to your previous commands.
Highlighted characters (hot-keys) on buttons and in menus can be selected at
any time to perform the action by pressing <ALT>hot-key.

How to Select a File in ComeBack

The first file in ComeBack's sorted list is initially selected (indicated by
the color or reverse video).  Using the cursor up and down arrow keys and the
{PgUp} and {PgDn} keys or the left mouse button, you can select any file for
recovery, deletion, or comparison.  Once selected, the path of the selected
file is displayed on the bottom line.

ComeBack allows you to select one or more files for deleting or recovering. 
Multiple files may be selected or deselected by hitting the letter T or by
double clicking the left mouse button. 


How to Recover a Selected File (or Files) using ComeBack

If only one file is selected, FileBack allows you recover the file in the
cursor bar to the same file name and directory from which it was deleted. 
This may be performed by either pressing the {Enter} key or clicking the left
mouse button.  
 
Alternately, you can edit this file specification to anything you desire.
While editing this specification, pressing any non cursor control key will
clear the current default specification and allow you to enter a new
specification. Pressing a cursor control key (left and right arrows, home and
end) will allow you to edit the current default specification. The {End} key
will move the cursor to the end of the line. The {Home} key will move the
cursor to the beginning of the line. The {Ins} key allows you toggle the edit
mode from insert to overwrite. The {Del} key will delete the character the
cursor is on. The {BkSp} key will delete the character before the cursor. The
{Esc} key or right mouse button will cancel the recover.

The Enter key or the left mouse button will start the recover. 

If more than one file is selected, all files are recovered to their original
file specifications.

The following keys are available during editing the file specification:

{Ins}        Toggles between insert and replace (overstrike) modes
{Home}       Moves the cursor to the beginning of the edit line
{End}        Moves the cursor to the end of the edit line
{Enter}      Starts the recovery
{Rt arrow}   Moves the cursor one character to the right
{Left arrow} Moves the cursor one character to the left
{BkSp}       Deletes the character to the left of the cursor
{Esc}        Cancel the recover

Typing any other key will delete the default filename and display the key
typed.  Thus if you desire to choose a completely different path and filename
to recover to, just enter the path and filename.

Example of Recovering a File

In summary, to recover a file using ComeBack requires the following steps:

1.   ComeBakr must have been running (usually started in your AUTOEXEC.BAT
     file) when the file was deleted.
2.   ComeBack must be run to recover the file.
3.   The proper file must be selected from the recovery list using the cursor
     control keys or the mouse.
4.   {Enter} must be pressed to begin the recovery (or Mouse)
5.   The destination filename must be entered.
6.   ComeBack may be exited with the {Esc} key or the Alt-X key.

How to Delete a Selected File using ComeBack

Once selected, a file (or files) in the recovery list can be deleted from the
recovery list (an thus become unrecoverable) using the "D" hot key (or
clicking on it with the left mouse button).

How to Compare a Selected File using ComeBack

Once selected, a file in the recovery list can be compared to any other file
on your system by pressing the "C" hot key (or clicking on it with the left
mouse button).  You will be prompted for the path and name of the file you
wish to compare with the selected file.  ComeBack defaults to the file which
matches the selected file's name and path.  You can either edit this to
compare the selected file with another or press {ENTER} to compare it with the
default.  (See "How to Recover a Selected File using ComeBack" for a
description of the edit keys)

ComeBack uses the file compare program FC to compare files.  If you have a
better compare program that takes the two file names as input and writes to
STDOUT, you can rename it to "FC" and ComeBack will use it for it's file
compares.

How to Turn ComeBack Off and On

If for any reason, you wish to work without ComeBack's protection, it can be
turned off at the DOS prompt with the following command:

[drive][path]COMEBAKR/OFF followed by the {ENTER} key.

When you are done, you may turn ComeBack on with the same command except with
an "ON" instead of the "OFF".  

In addition, if the ComeBack directory is in your path, you may preface any
command with an ! to turn ComeBack protection off.  For example, to delete all
of the *.TMP files and not provide ComeBack protection you could type:

  ! DEL *.TMP

How to Unload ComeBakr from Memory

If for any reason, you want to unload the RAM resident portion of ComeBack, it
can be unloaded at the DOS prompt with the following command:

[drive][path]COMEBAKR/U followed by the {ENTER} key

Once unloaded, ComeBack will not provide any protection until it is reloaded.
(See "How ComeBack is Started" to reload)

How to Remove All ComeBack Backup Files

In the event that you would want to remove all of ComeBack's recoverable files
and directories (which are all hidden), the CBREMOVE utility program is
available on your distribution floppy.  To remove ComeBack's recoverable
files, follow these simple steps:

1.   Insert the ComeBack disk into drive A (orB).
2.   At the DOS prompt, type A:CBREMOVE (or B:CBREMOVE), and press {ENTER}
3.   To continue, follow the instructions on the screen.
4.   When the removal is complete, open the door to drive A (or B), remove
     the disk and press CTRL+ALT+DEL to reboot the system.

How to Get Context Sensitive Help

At anytime, the Alt-H key will provide context sensitive help for the mode you
are in.  The Alt-G key will provide general help.  Help can also be accessed
by click on the Help and General Help buttons.

Notes Concerning ComeBack

1.   Networks - ComeBack will work on both peer to peer and server based
     networks.  The Network manager should be careful not to allow users to
     maintain the same copy of FILESVER.DIR.  This file was not designed for
     multi-user access.  For example, if users share a common directory
     structure on the server and designate this directory as drive H:, both
     users will assume they have exclusive access to FILESVER.DIR.  The users
     will require write privilege on the network if this file is maintained
     on the file server.

2.   Disk Usage - If you find that ComeBack is using too much disk space,
     find out what files are in the recovery list by running ComeBack with
     "*.*".  This will provide a list of the files in the recovery list and
     the amount of disk space they use.  If you see files that you did not
     generate, add their extensions to the exclusion list using CBCONFIG. 
     Optionally, modify the number of files in the recovery list using
     CBCONFIG (See "How to Reconfigure ComeBack" in Chapter 2).

3.   "BAK" Files - Certain programs create backup versions (with a variation
     on your filename) of the files that you are using without ever deleting
     or overwriting.  As a result, ComeBack does not record these files in
     the recovery list.  However, ComeBack will record the deletion of the
     backup files and these can be recovered.  Therefore, if you do not find
     your files in ComeBack's recovery list, use a "*.*" filename when using
     ComeBack to search for the variant filename.

4.   Use with TSR's (Terminate and Stay Resident programs) - if file
     modifying TSR's are run after ComeBakr, file activity performed by the
     TSR will be protected.  If run before ComeBakr, any file activity
     performed by the TSR will be unprotected.  The installation program does
     not take this ordering into account when modifying the AUTOEXEC.BAT
     file.  For example, if you are using a network, COMEBAKR should be run
     after the network TSR.

     If you are using TSR's, you must order them in your AUTOEXEC.BAT file.

5.   COMEBAKR utilizes 32k of EMS automatically if available.  If available,
     but the user does not desire to have COMEBAKR to utilize this memory (it
     makes it faster to have the memory), COMEBAKR should be installed with a
     /NOEMM switch.

6.   COMEBAKR will automatically load itself in high memory on versions of
     DOS 5.0 and greater if high memory is available.  If this causes any
     problems or if you desire ComeBakr to reside in low memory (below 640k),
     use the /NOHIGH switch.

Chapter 4 Error Messages


ComeBakr is already in memory - ComeBack recording can only be started once.

Fatal error: Must have DOS version 2.0 or later to use this program - obtain a
later version of DOS for your system.

Fatal error: Installation incomplete, no configuration found or wrong
configuration version - ComeBakr gives this message if the latest installation
has not been run or the configuration file on disk C: has been deleted.  See
"How to Install ComeBack" in Chapter 2.

Fatal error: Unable to access recoverable file list - The directory used to
keep the list of recoverable files has been deleted.  Re-boot.

Fatal error: Unable to remove.  ComeBakr is not on top - DOS only allows the
last RAM resident program to be removed.  Remove all RAM resident programs
that were loaded after ComeBakr before trying to remove it.

Fatal error: Unrecognized command, use /ON,/OFF, /U or /NOEMM - See chapters 3
and 4 to start ComeBack.


Chapter 5 Technical Specification


ComeBack Specification
A.     Must be installed to function.  Installation options:
     1.  The extensions to be excluded from recovery
     2.  The number of files in the recovery list (must be >=1 and <=1000)
         and the drives on which ComeBack is active
B.     Options take effect only when first run after re-boot
C.     Up to 1000 files may be recoverable at a time on each drive.
D.     A special directory will be created on each disk drive that has
       ComeBack enabled.
E.     Only non-removable hard drives are officially supported
F.     The number of bytes free on the disk is checked to be sure there is
       enough space - keeping 64k free as a minimum available after the
       operation
     1.  This is not done for delete operations
     2.  If not enough space is available, the recovery list may be
         shortened by 10 files from the installation value to get space. 
         If enough space is still not available the file will not be
         recoverable.
G.     ComeBack recording may be turned on and off at DOS level or it may be
       removed from memory (if it is at the top of the list).
H.     If the number of recoverable files is changed, on the next start up,
       the oldest files over this number will be deleted.
I.     Recording portion is a TSR that uses under 15k of memory.
J.     1 or 2 file handles need to be available for momentary use (if not
       available, the operation will not be performed).
K.     All of ComeBack is fully DOS compliant (2.0-6.2)
L.     Include/Exclude list limited to 60 characters.
M.     Max # of drives supported is 10.







